module FNV exposing (hashString)

{-| FNV hash function for hashing strings

@docs hashString

-}

import Bitwise
import Char


fnvPrime : Int
fnvPrime =
    (2 ^ 24) + (2 ^ 8) + 0x93


{-| Takes a string. Produces a hash (integer).

    hashString "Turn me into a hash" == 4138100590
-}
hashString : String -> Int
hashString str =
    String.foldl hashFold 0 str


hashFold : Char -> Int -> Int
hashFold c hash =
    ((Bitwise.xor hash (Char.toCode c)) * fnvPrime)
        |> Bitwise.shiftRightZfBy 0
